// dbghk_exts.cpp : Defines the entry point for the DLL application.
//


#include "stdafx.h"

#include "DbgPrnHk.h"
#include "..\client\dbgprint_opt.h"
#include "..\client\fmt_output.h"

WINDBG_EXTENSION_APIS   ExtensionApis;

VOID WinDbgExtensionDllInit(PWINDBG_EXTENSION_APIS PassedApis,USHORT Major,USHORT Minor) {
    memcpy(&ExtensionApis,PassedApis,sizeof(WINDBG_EXTENSION_APIS));
}

EXT_API_VERSION ExtapiVersion = { 5,5,0,0 };

LPEXT_API_VERSION ExtensionApiVersion(VOID) {
    return &ExtapiVersion;
}

DBGDUMP_OPT_RAW g_opt;

DWORD dwAddr_st = 0;
PDBGPRNHK_INTERNAL_STATE st = NULL;
PDbgPrnHk_GetMessages_USER_OUT MsgBuffer = NULL;

BOOL
WINAPI
DllMain(
    IN HANDLE DllHandle,
    IN DWORD  Reason,
    IN LPVOID Reserved
    )
{

    BOOL b;

    UNREFERENCED_PARAMETER(Reserved);

    b = TRUE;

    switch(Reason) {

    case DLL_PROCESS_ATTACH:

	dwAddr_st = 0;
	st = NULL;
	MsgBuffer = NULL;
	memset(&g_opt, 0, sizeof(g_opt));
        break;

    case DLL_THREAD_ATTACH:

        break;

    case DLL_PROCESS_DETACH:

        if(st) {
            free(st);
            st = NULL;
        }
        if(MsgBuffer) {
            free(MsgBuffer);
            MsgBuffer = NULL;
        }
        break;

    case DLL_THREAD_DETACH:

        break;
    }

    return (b);
}

PCHAR*
CommandLineToArgvA(
    PCHAR CmdLine,
    int* _argc
    )
{
    PCHAR* argv;
    PCHAR  _argv;
    ULONG   len;
    ULONG   argc;
    CHAR    a;
    ULONG   i, j;

    BOOLEAN  in_QM;
    BOOLEAN  in_TEXT;
    BOOLEAN  in_SPACE;

    len = strlen(CmdLine);
    i = ((len+2)/2)*sizeof(PVOID) + sizeof(PVOID);

    argv = (PCHAR*)malloc(
        i + (len+2)*sizeof(CHAR));

    _argv = (PCHAR)(((PUCHAR)argv)+i);

    argc = 0;
    argv[argc] = _argv;
    in_QM = FALSE;
    in_TEXT = FALSE;
    in_SPACE = TRUE;
    i = 0;
    j = 0;

    while( a = CmdLine[i] ) {
        if(in_QM) {
            if(a == '\"') {
                in_QM = FALSE;
            } else {
                _argv[j] = a;
                j++;
            }
        } else {
            switch(a) {
            case '\"':
                in_QM = TRUE;
                in_TEXT = TRUE;
                if(in_SPACE) {
                    argv[argc] = _argv+j;
                    argc++;
                }
                in_SPACE = FALSE;
                break;
            case ' ':
            case '\t':
            case '\n':
            case '\r':
                if(in_TEXT) {
                    _argv[j] = '\0';
                    j++;
                }
                in_TEXT = FALSE;
                in_SPACE = TRUE;
                break;
            default:
                in_TEXT = TRUE;
                if(in_SPACE) {
                    argv[argc] = _argv+j;
                    argc++;
                }
                _argv[j] = a;
                j++;
                in_SPACE = FALSE;
                break;
            }
        }
        i++;
    }
    _argv[j] = '\0';
    argv[argc] = NULL;

    (*_argc) = argc;
    return argv;
}

void
dpvmsg_help()
{
    dprintf("View DbgPrint Dump saved messages\n");
    dprintf("Usage:\n");
    dprintf("  ls [-h] [-i] [-a] [<1st message> [<last message> | -n <NUM messages>]]\n");
    dprintf("    -a           show all messages and summary info\n");
    dprintf("    --info       show summary info only (default)\n");
    dprintf("    --start NUM  show starting from NUM message in buffer\n");
    dprintf("    --count NUM  show not more than NUM messages\n");
    dprintf("    -m           show show initiator mode (K - kernel, U - user)\n");
    dprintf("    -p           show Process ID\n");
    dprintf("    -t           show Thread ID\n");
    dprintf("    -i           show IRQL\n");
    dprintf("    -cpu         show CPU number\n");
    dprintf("    --full       same as -m -p -t -i\n");
    dprintf("    -T           show timestamp\n");
    dprintf("    -fm M        do not show messages from <M> mode (<M> can be K or U)");

    return;
}
    
void
dpsmsg_help()
{
    dprintf("Save DbgPrint Dump saved messages to file\n");
    dprintf("Usage:\n");
    dprintf("  save [-h] [-a] [<1st message> [<last message> | -n <NUM messages>]] -f <FILENAME>\n");
    dprintf("    --file NAME  name of the file for saving messages\n");
    dprintf("    -a           save all messages\n");
    dprintf("    --start NUM  show starting from NUM message in buffer\n");
    dprintf("    --count NUM  show not more than NUM messages\n");
    return;
}
    
void
dp_dump_st(
    PDBGPRNHK_INTERNAL_STATE st
    )
{
    dprintf("Ver: %d.%d(%d)\n", st->Ver.Major, st->Ver.Minor, st->Ver.Sub);

    dprintf("MsgBuffer     = %#x\n", st->MsgBuffer);
    dprintf("ReadPosition  =%I64u\n", st->ReadPosition.QuadPart);
    dprintf("WritePosition =%I64u\n", st->WritePosition.QuadPart);
    dprintf("BufferSize    = %#x bytes\n", st->BufferSize);
    dprintf("BufferSizeMask= %#x (for item indexes)\n", st->BufferSizeMask);
    dprintf("QueueSize     = %#x\n", st->QueueSize);
    dprintf("MaxQueueSize  = %#x\n", st->MaxQueueSize);
    dprintf("CheckIrql     = %s\n", st->CheckIrql ? "Yes" : "No");
    dprintf("NoPassMsgDown = %s\n", st->NoPassMsgDown ? "Yes" : "No");
    dprintf("StopOnBufferOverflow = %s\n", st->StopOnBufferOverflow ? "Yes" : "No");
    dprintf("LoggingPaused = %s\n", st->LoggingPaused ? "Yes" : "No");
    dprintf("TimeStampType = %d, ", st->TimeStampType);
    switch(st->TimeStampType) {
    case TimeStampType_SysPerfCounter:
        dprintf("KeQueryPerformanceCounter()\n");
        break;
    case TimeStampType_RdtscPerfCounter:
        dprintf("Rdtsc CPU instruction\n");
        break;
    case TimeStampType_SysTime:
        dprintf("KeQuerySystemTime()\n");
        break;
    default:
        dprintf("unknown\n");
        break;
    }
    dprintf("BugCheckRegistered = %s\n", st->BugCheckRegistered ? "Yes" : "No");
}

#define DBGPRN_SHOW_PID   0x0001
#define DBGPRN_SHOW_TID   0x0002
#define DBGPRN_SHOW_IRQL  0x0004
#define DBGPRN_SHOW_CPU   0x0008
#define DBGPRN_SHOW_TIME  0x0010

#define TeeOutput(h, msg, len) \
                    dprintf("%.*s", len, msg);

void
dp_dump_msg(
    PDBGPRNHK_INTERNAL_STATE st,
    PDbgPrnHk_GetMessages_USER_OUT MsgBuffer,
    ULONG s,
    ULONG n,
    PCHAR fName
    )
{
    ULONG i;
    PDbgPrnHk_GetMessages_USER_OUT CurMsg;
    HANDLE h = NULL;
    ULONG returned;
    BOOLEAN write_failed = FALSE;
    CHAR buf[3] = "";
    CHAR DbgPrintBuf[4096];
    ULONG CurLogSize=0;
    ULONG len;

    DBGPRN_FORMAT_MESSAGE_CTX msgst;
    DBGPRN_TIMESTAMP_CTX      timest;

    if(fName) {
        h = CreateFile(fName, 0,
                           FILE_SHARE_READ | FILE_SHARE_WRITE,
                           NULL,
                           OPEN_EXISTING,
                           FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_NO_BUFFERING*/,  NULL);
        if(h && h != (HANDLE)(-1)) {
            dprintf("File %s already exists\n", fName);
            returned = GetInputLine("Overwrite (y/n)", &buf[0], 3);
            if(buf[0] != 'y' && buf[0] != 'Y') {
                dprintf("Please enter different name\n");
                return;
            }
        }
        dprintf("Saving messages to %s\n", fName);
        h = CreateFile(fName, GENERIC_READ | GENERIC_WRITE,
                           FILE_SHARE_READ | FILE_SHARE_WRITE,
                           NULL,
                           CREATE_ALWAYS,
                           FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_NO_BUFFERING*/,  NULL);
        if(!h || h == (HANDLE)(-1)) {
            dprintf("Cannot create message file\n");
            return;
        }
    }

    if(s || n != (ULONG)(st->WritePosition.QuadPart - st->ReadPosition.QuadPart)) {
        dprintf("Dumping %d messages starting from %d (%I64d absolute)\n",
            n, s, st->ReadPosition.QuadPart+s);
    }

    dbgprint_format_msg_init(&g_opt, &msgst);

    for(i=0; i<n; i++) {
        CurMsg = &MsgBuffer[(s+i) & st->BufferSizeMask];
        len = dbgprint_format_msg(&g_opt, CurMsg, DbgPrintBuf, &timest, &msgst);
        if(len) {
            dprintf("%.*s", len, DbgPrintBuf);
        }
        if(CheckControlC()) {
            dprintf("Stopped by Ctrl-C\n");
            break;
        }
    }
    if(h) {
        if(write_failed) {
            dprintf("%d messages were saved to file\n");
        } else {
            dprintf("All messages saved successfuly\n");
        }
        CloseHandle(h);
    }
}

int
dp_x_msg(
    PCHAR args,
    BOOLEAN View
    )
{
    DWORD dwAddr;
    DWORD dwAddr2;
    BOOL b;
    PCHAR* argv;
    int argc;
    int i, j;

    BOOLEAN   start_item_set = FALSE;
    ULONGLONG start_item = 0;
    BOOLEAN   end_item_set = FALSE;
    ULONGLONG end_item = -1;
    ULONG n=0;
    ULONG s=0;
    PCHAR fName = NULL;
    ULONG flags = 0;

    BOOLEAN all_mode = FALSE;
    BOOLEAN info_mode = FALSE;

    PDBGDUMP_OPT_RAW opt = &g_opt;
    UCHAR a;

#define print_log    dprintf

    // Evaluate the argument string to get the address of
    // the string to dump.

    if(!dwAddr_st) {
        dprintf("Connecting to DbgPrnHk, please wait\n");
        dwAddr = GetExpression("DbgPrnHk!DbgPrnHk_State");
        if ( !dwAddr ) {
            dwAddr = GetExpression("DbgPrnHk!st");
        }
        if ( !dwAddr ) {
            dprintf("Cannot find DbgPrnHk!DbgPrnHk_State export\n");
            return -1;
        }
        dwAddr_st = dwAddr;
    } else {
        dwAddr = dwAddr_st;
    }

    argv = CommandLineToArgvA((PCHAR)args, &argc);
    if(!argv) {
        dprintf("Cannot parse commandline\n");
        return -1;
    }

    if(!st) {
        dprintf("Reading DbgPrnHk internal state buffer, please wait\n");
        st = (PDBGPRNHK_INTERNAL_STATE)malloc(sizeof(DBGPRNHK_INTERNAL_STATE));
        if(!st) {
            dprintf("Cannot alloc memory for DbgPrnHk internal state buffer\n");
            return -1;
        }
        b = ReadMemory((ULONG)dwAddr,
                                  &dwAddr2,
                                  sizeof(dwAddr2),
                                  NULL);
        if ( !b ) {
            free(st);
            st = NULL;
            dprintf("Cannot read pointer to DbgPrnHk internal state\n");
            return -1;
        }
        b = ReadMemory((ULONG)dwAddr2,
                                  st,
                                  sizeof(DBGPRNHK_INTERNAL_STATE),
                                  NULL);
        if ( !b ) {
            free(st);
            st = NULL;
            dprintf("Cannot read DbgPrnHk internal state\n");
            return -1;
        }
    }

    if(!argc) {
        if(View) {
            all_mode = TRUE;
        } else {
            dprintf("Target file name required\n");
            return -1;
        }
    }

    for(i=0; i<argc; i++) {
        if(!argv[i]) {
            continue;
        }
        if(argv[i][0] != '-') {
            if(!start_item_set) {
                sscanf(argv[i], "%I64d", &start_item);
                start_item_set = TRUE;
            } else
            if(!end_item_set) {
                sscanf(argv[i], "%I64d", &end_item);
                end_item_set = TRUE;
            } else {
                dprintf("Invalid parameter %s\n", argv[i]);
                return -1;
            }
            continue;
        }
        if(!strcmp(argv[i], "-h") ||
           !strcmp(argv[i], "-?") ||
           !strcmp(argv[i], "//h") ||
           !strcmp(argv[i], "//?") ||
           !strcmp(argv[i], "--help")) {
            if(View) {
                dpvmsg_help();
            } else {
                dpsmsg_help();
            }
            return -1;
        } else
        if(!strcmp(argv[i], "-a")) {
            all_mode = TRUE;
        } else
        if(!strcmp(argv[i], "--info")) {
            if(!View) {
                goto unrec;
            }
            info_mode = TRUE;
        } else
        if(!strcmp(argv[i], "--file")) {
            if(View) {
                goto unrec;
            }
            i++;
            if(i >= argc) {
                dprintf("Missing filename after %s\n", argv[i-1]);
                return -2;
            }
            fName = argv[i];
        } else
        if(!strcmp(argv[i], "--count")) {
            i++;
            if(i >= argc) {
                dprintf("Missing message count after %s\n", argv[i-1]);
                return -2;
            }
            sscanf(argv[i], "%d", &n);
        } else
        if(!strcmp(argv[i], "--start")) {
            i++;
            if(i >= argc) {
                dprintf("Missing start message number after %s\n", argv[i-1]);
                return -2;
            }
            sscanf(argv[i], "%d", &s);
        } else

        #include "..\client\fmt_output_opt.h"
        
        {
unrec:
            dprintf("Unrecognized option %s\n", argv[i]);
            return -2;
        }
    }
    if(!all_mode && !info_mode) {
        all_mode = TRUE;
    }
    if(s) {
        start_item = st->ReadPosition.QuadPart + s;
    }
    if(n) {
        end_item = start_item + n;
    }
    if(start_item < (ULONGLONG)st->ReadPosition.QuadPart) {
        start_item = st->ReadPosition.QuadPart;
    }
    if(end_item >= (ULONGLONG)st->WritePosition.QuadPart) {
        end_item = st->WritePosition.QuadPart;
    }
    s = (ULONG)start_item & st->BufferSizeMask;
    n = (ULONG)(end_item - start_item);
    if(info_mode && View) {
        dp_dump_st(st);
    }
    if(all_mode) {
        if(!MsgBuffer) {
            MsgBuffer = (PDbgPrnHk_GetMessages_USER_OUT)malloc(st->BufferSize);
            if(!MsgBuffer) {
                dprintf("Cannot alloc memory for DbgPrnHk internal message buffer\n");
                return -1;
            }
            dprintf("Downloading message buffer, please wait.\n");
            b = ReadMemory((ULONG)st->MsgBuffer,
                                      MsgBuffer,
                                      st->BufferSize,
                                      NULL);
            if ( !b ) {
                free(MsgBuffer);
                MsgBuffer = NULL;
                dprintf("Cannot read DbgPrnHk internal message buffer\n");
                return -1;
            }
        }
        dp_dump_msg(st, MsgBuffer, s, n, fName);
    }
    return 1;
}

/*++

Routine Description:

--*/
DECLARE_API(ls) 

{
    dp_x_msg((PCHAR)args, TRUE);
}

DECLARE_API(list) 

{
    dp_x_msg((PCHAR)args, TRUE);
}

DECLARE_API(save) 
{
    dp_x_msg((PCHAR)args, FALSE);
}

DECLARE_API(help) {
    dprintf("ls|list   - view debug messages.\n");
    dprintf("save      - write debug messages to file\n");
}
